{ ----------- Wett-Screen ---------------- }

{ -------- Wahrscheinlichkeiten -------- }
function alphaquote(typ,p1,p2,p3:byte):real;
begin
   case typ of
   1: alphaquote:=q[p1,1];                                { Sieg }
   2: alphaquote:=q[p1,1]+q[p1,2]+q[p1,3];                { Platz }
   3: alphaquote:=q[p1,1]*q[p2,2]+q[p1,2]*q[p2,1];        { Zweier }
   4: alphaquote:=q[p1,1]*q[p2,2];                        { Zweier Einlauf }
   5: alphaquote:=q[p1,1]*(q[p2,2]*q[p3,3]+q[p2,3]*q[p3,2])       { Dreier }
                 +q[p2,1]*(q[p1,2]*q[p3,3]+q[p1,3]*q[p3,2])
                 +q[p3,1]*(q[p1,2]*q[p2,3]+q[p1,3]*q[p2,2]);
   6: alphaquote:=q[p1,1]*q[p2,2]*q[p3,3];                { Dreier Einlauf }
   end;
end;

procedure qmatrix(var w:matrix);
const eps=1e-18;  itmax=1000;
var i,j,iter:integer;
    fac,faq:real;
begin
   iter:=0;
   repeat
      faq:=0.0;
      for i:=1 to nhorses do begin
         fac:=0;
         for j:=1 to nhorses do fac:=fac+w[i,j];
         for j:=1 to nhorses do w[i,j]:=w[i,j]/fac;
         faq:=faq+(1.0-fac)*(1.0-fac);
         fac:=0;
         for j:=1 to nhorses do fac:=fac+w[j,i];
         for j:=1 to nhorses do w[j,i]:=w[j,i]/fac;
         faq:=faq+(1.0-fac)*(1.0-fac);
      end;
      inc(iter);
   until (faq<eps) or (iter>itmax);
end;


procedure wetteverbuchen(typ,p1,p2,p3:byte; dm,pool:real);
var i:byte;
    increment,f:real;
begin
   increment:=dm;
   case typ of
   1: w[p1,1]:=w[p1,1]+increment;
   2: begin
         f:=increment/3.0;
         for i:=1 to 3 do w[p1,i]:=w[p1,i]+f;
      end;
   3: begin
         f:=increment/2.0;
         for i:=1 to 2 do w[p1,i]:=w[p1,i]+f;
         for i:=1 to 2 do w[p2,i]:=w[p2,i]+f;
      end;
   4: begin
         f:=increment/1.0;
         w[p1,1]:=w[p1,1]+f;
         w[p2,2]:=w[p2,2]+f;
      end;
   5: begin
         f:=increment/3.0;
         for i:=1 to 3 do w[p1,i]:=w[p1,i]+f;
         for i:=1 to 3 do w[p2,i]:=w[p2,i]+f;
         for i:=1 to 3 do w[p3,i]:=w[p3,i]+f;
      end;
   6: begin
         f:=increment/1.0;
         w[p1,1]:=w[p1,1]+f;
         w[p2,2]:=w[p2,2]+f;
         w[p3,3]:=w[p3,3]+f;
      end;
   end;
   q:=w;
   qmatrix(q);
end;

procedure initwmatrix;
var i,j:byte;
begin
for i:=1 to nhorses do for j:=1 to nhorses do w[i,j]:=100.0;
q:=w;
qmatrix(q);
end;

{ --- }


procedure showquoten;
const ox=440; oy=48; dy=12;
var i:byte;
begin
   rectfill(ox,oy+dy,ox+127,oy+pred(succ(nhorses)*dy),2);
   for i:=1 to nhorses do with pferd[i] do begin
      quote:=trunc(10.0/alphaquote(1,i,2,3)+0.5);
      if quote<10.0 then quote:=10;
      if quote>9999.0 then quote:=9999;
      platz:=trunc(10.0/alphaquote(2,i,2,3)+0.5);
      if platz<10.0 then platz:=10;
      if platz>9999.0 then platz:=9999;
      str(quote:4,t1);
      t1:=t1+':10';
      setcolor(1); outtextxy(ox+1,oy+i*dy,t1);
      setcolor(0); outtextxy(ox,oy+i*dy,t1);
      str(platz:4,t1);
      t1:=t1+':10';
      setcolor(1); outtextxy(ox+65,oy+i*dy,t1);
      setcolor(0); outtextxy(ox+64,oy+i*dy,t1);
  end;
end;

procedure showhorseinfo(nr:word);
const ox=40; oy=160; dx=508; dy=12;
var i:byte;
    f:text;
begin
   rectfill(ox,oy,ox+pred(dx),oy+pred(dy*7),4);
   setcolor(3); outtextxy(ox+1,oy,pferdinfo[nr,0]);
   setcolor(7); outtextxy(ox,oy,pferdinfo[nr,0]);
   line(ox,oy+10,ox+pred(dx),oy+10);
   for i:=1 to 6 do begin
      setcolor(3); outtextxy(ox+1,oy+4+i*dy,pferdinfo[nr,i]);
      setcolor(7); outtextxy(ox,oy+4+i*dy,pferdinfo[nr,i]);
   end;
   putimage(dx-ox,oy+9*dy,maske[1].p_data^,andput);
   putimage(dx-ox,oy+9*dy,pferd[nr].ima[1].p_data^,orput);
end;

procedure zeichnewettscreen;
const ox=40; oy=160; dx0=508; dy0=12;
var x,y,dx,dy,i,j,k:word;
begin
rectfill(0,0,639,479,0);
{ --- Header: --- }
rectfill(0,0,639,15,11);
setcolor(1); line(1,1,1,14);    line(1,1,638,1);
setcolor(0); line(1,14,638,14); line(638,2,638,14);
t1:='W e t t s c h a l t e r                        (c) uja - TP6';
setcolor(1); outtextxy(129,4,t1);
setcolor(7); outtextxy(128,4,t1);

{ - 1.Info-Tafel: - }
x:=16; y:=32; dx:=560; dy:=100;
rectfill(x,y,x+pred(dx),y+pred(dy),2);
setcolor(1);  line(x+1,y+1,x+dx-2,y+1);       line(x+1,y+1,x+1,y+dy-2);
setcolor(0);  line(x+1,y+dy-2,x+dx-2,y+dy-2); line(x+dx-2,y+2,x+dx-2,y+dy-2);
setcolor(9);  line(x+7,y+7,x+dx-8,y+7);       line(x+7,y+7,x+7,y+dy-8);
setcolor(11); line(x+7,y+dy-8,x+dx-8,y+dy-8); line(x+dx-8,y+8,x+dx-8,y+dy-8);
t1:='Bahn                              Jockey              Sieg   Platz';
setcolor(1); outtextxy(x+17,y+12,t1);
setcolor(0); outtextxy(x+16,y+12,t1);

for i:=1 to nhorses do begin
   str(i:1,t1);
   t1:=t1+'. '+pferd[i].pferdename;
   setcolor(1); outtextxy(x+21,y+16+i*12,t1);
   setcolor(0); outtextxy(x+20,y+16+i*12,t1);
   case i of
   1: t1:='Palomino   ';
   2: t1:='Fuchs      ';
   3: t1:='Rappe      ';
   4: t1:='Schimmel   ';
   5: t1:='Grautier   ';
   end;
   t1:=t1+pferd[i].jockey;
   setcolor(1); outtextxy(x+197,y+16+i*12,t1);
   setcolor(0); outtextxy(x+196,y+16+i*12,t1);
end;
showquoten;
{ - 2.Info-Tafel: - }
x:=16; y:=144; dx:=560; dy:=120;
rectfill(x,y,x+pred(dx),y+pred(dy),4);
setcolor(1);  line(x+1,y+1,x+dx-2,y+1);       line(x+1,y+1,x+1,y+dy-2);
setcolor(0);  line(x+1,y+dy-2,x+dx-2,y+dy-2); line(x+dx-2,y+2,x+dx-2,y+dy-2);
setcolor(5);  line(x+7,y+7,x+dx-8,y+7);       line(x+7,y+7,x+7,y+dy-8);
setcolor(3); line(x+7,y+dy-8,x+dx-8,y+dy-8); line(x+dx-8,y+8,x+dx-8,y+dy-8);
putimage(dx0-ox-1,oy+9*dy0,maske[1].p_data^,notput);
end;



procedure wettkarte;
var t0:string;  i:integer;
const ox=16; oy=336; dx=48; dy=16;
begin
   rectfill(ox-8,oy-8,ox+12*dx+8,oy+8*dy+8,14);
   setcolor(15);
   rectangle(ox-4,oy-4,ox+12*dx+4,oy+8*dy+4);
   rectfill(ox,oy,ox+12*dx,oy+8*dy,15);

   setcolor(0);
   t0:='Pferd Sieg  Platz 2er-1 2er-2 3er-1 3er-2 3er-3 Einl. Betrag';
   outtextxy(ox+8,oy+dy,t0);
   for i:=1 to nhorses do begin
      str(i:1,t0);
      t0:='  #'+t0;
      outtextxy(ox+8,oy+(i+1)*dy+4,t0);
      line(ox,oy+(i+1)*dy,ox+12*dx,oy+(i+1)*dy);
      case i of
      1: t0:='  5 DM';
      2: t0:=' 10 DM';
      3: t0:=' 20 DM';
      4: t0:=' 50 DM';
      5: t0:='100 DM';
      else t0:=' ---  ';
      end;
      outtextxy(ox+8+10*dx,oy+(i+1)*dy+4,t0);
   end;
   line(ox,oy+(nhorses+2)*dy,ox+12*dx,oy+(nhorses+2)*dy);
   for i:=1 to 9 do line(ox+i*dx,oy+2*dy,ox+i*dx,oy+(nhorses+2)*dy);
end;

procedure wettemarkieren(zocker,nr:byte);
const ox=16; oy=352; dx=48; dy=16;
var i,j,k,mx,my,key:integer;
begin
   maustastelos(key,mx,my);
   if key=1 then begin
      my:=(my-oy) div dy;
      if (my>0) and (my<6) then begin
         mx:=(mx-ox) div dx;
         if mx>9 then mx:=9;
         hidemouse;
         with wette[zocker,nr] do case mx of
         1,2: begin
              wettyp:=mx;
              pferd[1]:=my;
              for j:=1 to 8 do for i:=1 to nhorses do begin
                 k:=15;
                 if j=mx then if i=pferd[1] then k:=14;
                 rectfill(ox+j*dx+4,oy+i*dy+4,
                          ox+(j+1)*dx-4,oy+(i+1)*dy-4,k);
              end;
              end;
         3,4: begin
              wettyp:=3;
              pferd[mx-2]:=my;
              for j:=1 to 8 do for i:=1 to nhorses do begin
                 k:=15;
                 if j=3 then if i=pferd[1] then k:=14;
                 if j=4 then if i=pferd[2] then k:=14;
                 rectfill(ox+j*dx+4,oy+i*dy+4,
                          ox+(j+1)*dx-4,oy+(i+1)*dy-4,k);
              end;
              end;
      5,6,7:  begin
              wettyp:=5;
              pferd[mx-4]:=my;
              for j:=1 to 8 do for i:=1 to nhorses do begin
                 k:=15;
                 if j=5 then if i=pferd[1] then k:=14;
                 if j=6 then if i=pferd[2] then k:=14;
                 if j=7 then if i=pferd[3] then k:=14;
                 rectfill(ox+j*dx+4,oy+i*dy+4,
                          ox+(j+1)*dx-4,oy+(i+1)*dy-4,k);
              end;
            end;
      8  :  begin
               if wettyp in [3,5] then inc(wettyp)
               else if wettyp in [4,6] then dec(wettyp);
               if wettyp in [3,5] then j:=15;
               if wettyp in [4,6] then j:=14;
               if wettyp in [3..6] then rectfill(ox+mx*dx+4,oy+dy+4,
                                         ox+(mx+1)*dx-4,oy+2*dy-4,j);
            end;
      9  : begin case my of
            1: betrag:=5.00;
            2: betrag:=10.0;
            3: betrag:=20.0;
            4: betrag:=50.0;
            5: betrag:=100.0;
            end;
            for i:=1 to nhorses do begin
               k:=15;
               if i=my then k:=14;
               rectfill(ox+mx*dx+4,oy+i*dy+4,
                          ox+(mx+1)*dx-4,oy+(i+1)*dy-4,k);
            end;
            end;

      end;
      showmouse;
  end;
  end;
end;

procedure wetteannehmen(var i,j:integer; var next,ende:boolean);
begin
wettkarte;
str(j:1,t1);
t1:=spieler[i].name+': Wettkarte '+t1;
str(spieler[i].geld:8:2,t2);
t1:=t1+'  -   Moneten: '+t2+' DM';
rectfill(16,288,456,323,7);
setcolor(1); outtextxy(24,296,t1);
t1:='Wette/Betrag anklicken, buchen:< > nchster Zocker:<N>';
setcolor(3); outtextxy(24,308,t1);

showmouse;
repeat  { Pferdeinfo holen }
   ch:='.';
   if keypressed then ch:=readkey else wettemarkieren(i,j);
   ende:=ch=#27;
   next:=(ch in ['N','n']);
   if (ch>#48) and (ord(ch)<49+nhorses) then showhorseinfo(ord(ch)-48);
until (ch=#32) or ende or next;
hidemouse;
end;


